plugins {
    id("com.android.library")
    id("org.jetbrains.kotlin.android")
    id("com.google.devtools.ksp")
}

android {
    namespace = "com.isidroid.network"
    compileSdk = BuildVersions.COMPILE_SDK

    defaultConfig {
        minSdk = BuildVersions.MIN_SDK

        testInstrumentationRunner = "androidx.test.runner.AndroidJUnitRunner"
        consumerProguardFiles("consumer-rules.pro")
    }

    buildTypes {
        release {
            isMinifyEnabled = false
            proguardFiles(getDefaultProguardFile("proguard-android-optimize.txt"), "proguard-rules.pro")
        }
    }
    compileOptions {
        sourceCompatibility = JavaVersion.VERSION_17
        targetCompatibility = JavaVersion.VERSION_17
    }
    kotlinOptions {
        jvmTarget = "17"
    }
}

dependencies {
    api(project(mapOf("path" to ":core:core")))
    api(project(mapOf("path" to ":core:utils")))


    api("androidx.core:core-ktx:${GoogleVersions.coreKtx}")
    api("androidx.appcompat:appcompat:${GoogleVersions.appCompat}")
    api("com.google.dagger:hilt-android:${GoogleVersions.hilt}")
    ksp("com.google.dagger:hilt-compiler:${GoogleVersions.hilt}")

    // tools
    api("com.jakewharton.timber:timber:${ToolsVersions.timber}")

    // network
    api("com.squareup.okio:okio:${NetworkVersions.okio}")
    api("com.squareup.retrofit2:retrofit:${NetworkVersions.retrofit}")
    api("com.squareup.okhttp3:okhttp:${NetworkVersions.okhttp}")
    api("com.squareup.retrofit2:converter-gson:${NetworkVersions.retrofit}")
    api("com.squareup.okhttp3:logging-interceptor:${NetworkVersions.okhttp}")


    testApi(project(":core:test_utils"))
    testImplementation("junit:junit:${TestVersions.junit}")
    androidTestImplementation("androidx.test.ext:junit:${TestVersions.junitExt}")
    androidTestImplementation("androidx.test.espresso:espresso-core:${TestVersions.espressoCore}")

    testImplementation("com.squareup.okhttp3:mockwebserver:${TestVersions.mockWebServer}")
    testImplementation("org.mockito:mockito-core:${TestVersions.mockitoCore}")
    testImplementation("org.mockito.kotlin:mockito-kotlin:${TestVersions.mockitoKotlin}")
    testImplementation("org.robolectric:robolectric:${TestVersions.robolectric}")
}